;	cpu	Z80UNDOC	;wg LY, HY

	;PN	HEADERSAVE_5.9	
;
;**********************************************************
;       SAVE-LOAD-ROUTINE MIT KOPF, BLOCKNUMMERN 
;       UND VERIFY-FUNKTION  5.9
;             Z 1013
;
;       Copyrights by Rainer Brosig 14.10.87
;       W.-Florin-Str.2c, COSWIG, 8270
;
;
;**********************************************************

;
TYPP:	EQU	PUANF-4H	; TYPKENNZEICHENZELLE PUFFER
;ARG1:	EQU	1BH		; PARAMETER 1 
;ARG2:	EQU	1DH		; PARAMETER 2 
CURSR:	EQU	2BH		; AKTUELLE CURSORPOSITION
;ARG3:	EQU	23H		; PARAMETER 3
ARG1P:	EQU	PUANF-10H	; ARG1 PUFFER
ARG2P:	EQU	PUANF-0EH	; ARG2 PUFFER
ARG3P:	EQU	PUANF-0CH	; STARTADRESSE IM PUFFER
;SOIL:	EQU	16H		; ANF.ADR.EINGABEZEILE
PUANF:	EQU	0F0H		; PUFFERANFANG NAME
;MONTB:	EQU	0B0H		; ANF.Z-MON-TAB RAM
;DATA:	EQU	13H		; KOPFADR. DES LETZTEN BLOCKS
ZILAD:	EQU	25H		; KOPFADR. VORLETZTER BL.
;
; LORUF: 
; ext. Laderuf gesamtes File
;       Parameterbergabe:
;        Zelle 1BH/1CH * neue Ladeadr. File, sonst 0 !
;        Akku          *  0  - ohne Typ+Namenkontrolle
;                      * 4EH - mit Typ+Namenkontrolle
;        H(IY)         *  0  - Typ wird abgefragt
;                      * TKZ - Typvorgabe --> keine Typabfrage
;        L(IY)         * 20H - Autostartfreigabe bei COM-File
;       ! der 1.Registersatz+AF' werden zerstrt
;
;
; SARUF:
; ext.Saveruf gesamtes File
;       Parameterbergabe:
;        Zelle 1BH * Anfangsadresse
;              1DH * Endadresse
;              23H * Startadresse
;        Akku      * 3AH - Wiederholen der Saverout. m. gl. Kopf
;        H(IY)     * TKZ - keine Abfrage Typ
;                  *  0  - Abfr. Typ
;       ! der 1.Registersatz+AF' werden zerstrt
;
;
; LOAD:
;  Aufruf durch Z-Monitor
;
;
; SAVE:
;  Aufruf durch Z-Monitor
;
;
; BLMK:
;  ext. Ruf zum Lesen eines Blocks
;         Parameterbergabe:
;          Zelle 25H/26H * Kopfinhalt des zu lesenden Blocks
;          HL            * Ladeadr. des Blocks
;         Return:
;          Zelle 25H/26H * Kopfinhalt + 20H
;
;
; BSMK:
;  ext. Ruf Schreiben eines Blocks
;         Parameterbergabe:
;          HL  * Quelladr. Block
;          IX  * Kopfinhalt
;          DE  * Anzahl der Sync.-Bits
;         Return:
;          HL  * HL:=HL+20H
;
;
; SUCHK:
;  sucht einen Kopfblock und bergibt den Inhalt im Puffer
;         Puffer: 0E0H-0FFH
;
;
; AKP:
;  bereitet einen Kopfpuffer bei 0E0H auf
;          HY=0 - Abfrage Typ
;          HY=TYP - Typvorgabe
;          DE, BC werden zerstrt
;
;Kopfaufbau: Bit  0 - 1  Anfangsadr.
;                 2 - 3  Endadr.
;                 4 - 5  Startadr.
;                 6 -0BH frei fr Zusatzinformationen
;                  0CH   Typkennzeichen
;                0DH-0FH 3x0D3H = Kopfkennzeichen
;                10H-1FH 16 Byte Namensblock
;
;
;
;	ORG	3C00H
;	ORG	0E000H	
;
LORUF:	JP	LORU1		;EXT.LADERUF FILE
SARUF:	JP	SARU1		;EXT.SAVERUF FILE
LOAD:	JP	LOAD1		;MONITOR-LADERUF FILE 
SAVE:	JP	SAVE1		;MONITOR-SAVERUF FILE
BLMK:	JP	BLMK1		;BLOCK LESEN MIT KOPF
BSMK:	JP	BSMK1		;BLOCK SCHR. MIT KOPF
SUCHK:	JP	SUCH1		;SUCHEN EINES KOPFBLOCKES
AKP:	JP	KAUFB		;KOPFAUFBEREITUNG
;
;***********************************
;	SAVE	MIT NAME	
;***********************************

; 
SAVE1:	LD	IYU,0		;LOESCHEN TYP-KZ
SARU1:	CP	A, 3AH		;WIEDGRHOLEN MIT GLEICHEN
	CALL	NZ, KAUFB	;PARAMETERN BEI A=':'
	RST	20H	
	DB	2,8DH	
	CALL	L1	
	LDIR		
	LD	HL,PUANF-10H	
	CALL	BSA	
	LD	HL,(ARG1P)	
	CALL	PRTHL		;AUSGABE MEMORYPOINTER
	CALL	BSA		;SCHREIBEN ANFANGSBLOCK
	CALL	DS1		;SPEICHERAUSG.BIS ARG2
	CALL	VERIF	
	RET		
;
;***********************************
;UP	- KOPFAUFBEREITUNG IM PUFFER	
;***********************************

;
KAUFB:	CALL	L1	
	EX	DE,HL	
	LDIR			;FLLEN PUFFER ARG1 U. 2
	LD	HL,(ARG3)	
	LD	(ARG3P),HL	;ARG3
	LD	HL,PUANF-3H	
	LD	A,0D3H		;KOPFKENNZEICHEN -> PUFFER
	LD	B,3	
KOKZ:	LD	(HL),A	
	INC	HL	
	DJNZ	KOKZ		;3*D3H=KZ-NAMEN
	CALL	L3		;EING.TYP U.NAME
	LD	A,IYU	
	LD	(TYPP),A	
	LD	HL,(SOIL)	
	LD	BC,10H	
	LD	DE,PUANF	
	LDIR			;LADEN PUFFER MIT NAME
	RST	20H	
	DB	2,8DH	
	RET		
;
;AUSGABE SPEICHERBEREICH
;
DS1:	EX	DE,HL	
	LD	HL,(ARG2P)	;ENDADRESSE
	AND	A, A	
	SBC	HL,DE	
	EX	DE,HL	
	RET	C	
	LD	(ZILAD),HL	
	CALL	BS	
	CALL	PRTHL	
	JR	DS1	
;
;UP	- VERIFY 	
;
VERIF:	RST	20H	
	DB	2,"verify? (Y)",0BAH	
	RST	20H	
	DB	1H	
	CP	A, 59H		;'Y'
	CCF		
	RET	NZ	
	RST	20H	
	DB	2H," rewind ",0BCH	
	RST	20H	
	DB	1H	
	RST	20H	
	DB	2H,0DH,8DH	
SUCH0:	CALL	BLBS	
	JR	NZ, SUCH0	
	LD	A,PUANF-10H	
	CP	A, E	
	JR	NZ, SUCH0	
	XOR	A	
	CP	A, D	
	JR	NZ, SUCH0	
VERGL:	CALL	BLBS	
	CALL	NZ, BADRC	
	RET	NZ	
	LD	H,D	
	LD	L,E	
	CALL	PRTHL	
	LD	A,(ZILAD)	
	CP	A, E	
	JR	NZ, VERGL	
	LD	A,(ZILAD+1)	
	CP	A, D	
	JR	NZ, VERGL	
	CALL	CURIN	
	RET		
;
;SCHREIBEN BLOCK AUF BS
;
BLBS:	LD	A,0FFH	
	LD	(ARG2+1),A	
	LD	HL,0EC00H	
	CALL	BL	
	RET		
;
;***********************************
;LOAD	MIT NAME	
;***********************************

; 
LOAD1:	LD	HL,(SOIL)	
;	INC	HL	
;	INC	HL	
;	INC	HL		;POINTER 3.ZEICHEN
	call	sub_FBEE
	LD	A,(HL)	
	LD	IYL,A		;LD L(IY),A (KZ-SPERRE)
	DEC	HL	
	LD	IYU,0		;LD H(IY),A (KEIN TYP)
	LD	A,(HL)		;A=2.BUCHST.
LORU1:	LD	HL,DATA+2	
	LD	(HL),0		;LSCHEN ZEICHENZHLER
	CP	A, 4EH		;EINSPRUNG ANWENDERPROGR.
	PUSH	HL	
	CALL	Z, L3		;LADEN NAME+TYP
	POP	HL	
	LD	HL,(ARG1)	
	LD	(ARG3),HL	;RETTEN NEUE ADR.
SUCH9:	CALL	SUCH1		;SUCHEN EINES KOPFES
	RST	20H	
	DB	2,8DH	
	LD	B,3H	
	LD	HL,(ARG1P)	
	LD	(ZILAD),HL	
	LD	HL,ARG1P+1	
DRARG:	RST	20H		;DRUCKEN DER 3 ARGUMENTE
	DB	0CH		;OTHLS
	INC	HL	
	INC	HL	
	INC	HL	
	INC	HL	
	DJNZ	DRARG	
	RST	20H	
	DB	2,0DH,8DH	
	LD	HL,PUANF-4	
	LD	DE,(CURSR)	
	LD	BC,14H	
	LDIR			;DRUCKEN DES NAMENSBLOCKS
	INC	DE		;SPACE NACH NAME
	LD	(CURSR),DE	
LSTOP:	LD	A,IYU		;LD A,H(IY)
	CP	A, 21H		;TEST AUF TYPKONTROLLE
	JR	C, LOAD5	;KEINE TYPKONTROLLE 
	LD	HL,TYPP	
	CP	A, (HL)	
	CALL	NZ, ERROR	
	JR	NZ, SUCH9	;TYP NICHT OK
LOAD5:	LD	A,(DATA+2)	
	LD	B,A	
	OR	A		;TEST AUF NAMENSSIGNIF.
	JR	Z, LOAD6	
	LD	HL,PUANF	
	LD	DE,(SOIL)	
LOAD7:	LD	A,(DE)	
	CP	A, (HL)		;NAMENSKONTROLLE
	INC	HL	
	INC	DE	
	CALL	NZ, ERROR	
	JP	NZ, SUCH9	
	DJNZ	LOAD7	
LOAD6:	LD	HL,(ARG3)	
	XOR	A	
	OR	H		;TEST AUF >0FFH
	JR	Z, CL1		;BEI <100H KEINE NEUE AADR.
	LD	BC,(ARG1P)	
	LD	(ARG1P),HL	
	RST	20H	
	DB	7H		;OUTHL
	RST	20H	
	DB	0EH		;OUTSP
	SBC	HL,BC	
	LD	BC,(ARG2P)	
	ADD	HL,BC	
	LD	(ARG2P),HL	
	RST	20H	
	DB	7H		;OUTHL
;
;EINLESEN FILE
;  
CL1:	RST	20H	
	DB	2,0DH,8DH	
	CALL	L1	
	LDIR			;BERNEHMEN DER PARAMETER
	EX	AF, AF'		;KZALT RETUR
	PUSH	AF	
	CALL	Z, BADRC+3	;OHNE CURIN
	POP	AF	
	RET	Z		;ABBRECHEN ALTE B. BLCKE
	LD	HL,(ARG1P) 	
DLMO:	CALL	PRTHL	
	CALL	BLMK1	
	EX	DE,HL	
	LD	HL,(ARG2P)	
	OR	A		;CY=0
	SBC	HL,DE	
	EX	DE,HL	
	JR	NC, DLMO	
	LD	HL,(ARG2P)	
	CALL	PRTHL	
	CALL	CURIN	
;
;AUTOSTART?
;
	LD	HL,(ARG3P)	
	LD	(ARG3),HL	
	LD	A,(TYPP)	
	CP	A, 43H		;KONTROLLE C-FILE
	CCF		
	RET	NZ	
	LD	A,IYL		
	CP	A, 20H		;KONTROLLE SPERRE
	RET	NZ	
	JP	(HL)		;AUTOSTART
;
;
;SUCHEN NACH KOPFBLOCK
;
SUCH1:	RST	20H	
	DB	4H		;ABRUCH DURCH BREAK
	CP	A, 3H	
	JR	NZ, KBRAK	
	RST	20H	
	DB	2,8DH	
	POP	AF		;STACKKOR.
	RET		
KBRAK:	LD	A,15+PUANF 	
	LD	(ARG2),A	
	LD	HL,PUANF-10H	
	CALL	BL		;LADEN KOPFBLOCK
	JR	NZ, SUCH1	
	LD	A,D	
	OR	E		;FESTSTELLEN OB BLOCKNR.
	EX	AF, AF'		;KZALT->AF'
	LD	B,3H	
	LD	HL,PUANF-3	
KOKO:	LD	A,(HL)	
	CP	A, 0D3H		;KONTROLLE KOPFBLOCK
	INC	HL	
	JR	NZ, SUCH1	
	DJNZ	KOKO	
	RET		
;
;**************************************
;UP	- LESEN EINES BLOCKS MIT KONTROLLE	
; INPUT: (ZILAD) - ZU LESENDER BLOCK
;          HL    - DMA
; OUTPUT: (ZILAD)- NAECHSTER ZU LESENDE BLOCK
;**************************************
;
BLMK1:	CALL	BL	
	JR	Z, DLM3	
;
; BLOCKSUCHEN
;
BADR:	CALL	BADRC	
INCHR:	RST	20H	
	DB	1	
	CP	A, 03H	
	JR	Z, BLMR	
	RST	20H	
	DB	2,0DH,8DH	
SUCHB:	LD	BC,20H	
	AND	A, A	
	SBC	HL,BC	
WIED:	CALL	BL	
	JR	NZ, SUCHB	
	LD	A,D	
	AND	A, E	
	INC	A	
	JR	Z, BLMR	
DLM3:	PUSH	HL	
	LD	HL,(ZILAD)	
	EX	DE,HL	
	SBC	HL,DE	
	POP	HL	
	JR	Z, DLM1	
	JR	C, SUCHB	
	CALL	RECER	
	CALL	ERROR	
	JR	INCHR	
DLM1:	PUSH	HL	
	LD	HL,20H	
	ADD	HL,DE	
	LD	(ZILAD),HL	
BLMR:	POP	HL	
	RET		
;
;
;++++++++++++++++++++++++++++++++++
;ARGUMENTE	LADEN	
;
L1:	LD	HL,ARG1P	
	LD	DE,ARG1	
	LD	BC,4H	
	RET		
;
;++++++++++++++++++++++++++++++++++
;TYP	+ NAME LADEN	
;
L3:	DB	0FDH	
	LD	A,H		;TYPVORGABE?
	OR	A	
	JR	NZ, KTYP	
	RST	20H	
	DB	2H,0DH,"typ",0BAH	
	RST	20H	
	DB	1H		;INCHAR
	CP	A, 20H		;<20H=KZ KEINE TYPENKONTR.
	JR	NC, L31	
	LD	A,20H	
L31:	RST	20H	
	DB	0		;OUTCHAR
	LD	IYU,A		;SPACE=KZ FUER OHNE TYP
KTYP:	RST	20H	
	DB	2H," filename",0BAH	
	LD	HL,(CURSR)	
	LD	(SOIL),HL	
	LD	C,0FFH	
ZKINP:	INC	C	
	RST	20H	
	DB	1	
	CP	A, 3	
	JP	Z, LRET	
	CP	A, 8	
	JR	NZ, OUTCHx	
	DEC	C	
	JP	M, ZKINP	
ENDE:	DEC	C	
OUTCHx:	RST	20H	
	DB	0	
	CP	A, 0DH	
	LD	A,C	
	LD	(DATA+2),A	
	RET	Z	
	LD	A,10H		;16 ZEICHEN
	CP	A, C	
	LD	A,8	
	JR	NZ, ZKINP	
	JR	ENDE	
;
;++++++++++++++++++++++++++++++++++
;FEHLERMELDUNGEN		
;++++++++++++++++++++++++++++++++++

;
BADRC:	CALL	CURIN	
	RST	20H	
	DB	2,"bad",0A0H	
RECER:	RST	20H	
	DB	2,"record",0A0H	
	RET		
ERROR:	RST	20H	
	DB	2,"not found",8DH	
	RET		
;
;*******************************************
;UP		
;*******************************************

;
BSA:	LD	DE,1000H	;KENNTONLAENGE
	JR	BSX	
BS:	LD	DE,0EH ; 14
BSX:	PUSH	HL	
	POP	IX	
BSMK1:	LD	B,8Ch ; 112		;VORBLOCK
BSX1:	DJNZ	BSX1	
	CALL	FLOUT	
	DEC	DE	
	LD	A,E	
	OR	D	
	JR	NZ, BSMK1	
	LD	C,2	
BSMO:	LD	B,42h; 53	
BSX5:	DJNZ	BSX5	
	CALL	FLOUT	
	DEC	C	
	JR	NZ, BSMO	
	PUSH	IX		;IX=KOPFINHALT
	POP	DE		
	LD	B,16h ; 18		;BSNO AUSGABE KENNZEICHEN
BSXO:	DJNZ	BSXO	
	CALL	WS		;SCHREIBEN EINES DOPPELBYTES
	LD	B,12h ; 15	
BSW1:	DJNZ	BSW1	
	LD	C,16		;DATEN 16x16=32x8
BSM1:	LD	E,(HL)	
	INC	HL	
	LD	D,(HL)	
	ADD	IX,DE		;AUFADDIEREN CHECKSUMME
	INC	HL	
	PUSH	BC	
	CALL	WS	
	POP	BC	
	DEC	C	
	JR	Z, BSM2	
	LD	B,11h ; 14	
BSX2:	DJNZ	BSX2	
	JR	BSM1	
BSM2:	PUSH	IX		;ENDE DATEN
	POP	DE		;AUSGABE CHECKSUMME
	LD	B,14h ; 16	
BSX3:	DJNZ	BSX3	
	CALL	WS	
	RET		
;
;
;*******************************************
;UP	- AUSGABE EINES WORTES - 16 BIT AUS DE	
;*******************************************
;
WS:	LD	C,16	
WSMO:	SRL	D	
	RR	E	
	JR	NC, WSM1	
	LD	B,4 ; 3		;WSN1...
BSWS1:	DJNZ	BSWS1	
	NOP		
	JR	WSM3	
WSM1:	CALL	FLOUT	
WSM3:	LD	B,1Fh ; 25		;WSN2...
BSWS2:	DJNZ	BSWS2	
WSM2:	CALL	FLOUT	
	DEC	C	
	RET	Z	
	LD	B,1Ah ; 21		;WSN3...
BSWS3:	DJNZ	BSWS3	
	JR	WSMO	
;
;************************************
;UP	- FLANKENAUSGABE BIT 7 PORT B	
;************************************
;
FLOUT:	IN	A, 2	
	XOR	80H	
	OUT	2, A	
	RET		
;
;************************************
;AUSGABE	HL AUF GLEICHER POSITION	
;************************************
;
PRTHL:	PUSH	DE	
	PUSH	HL	
	LD	DE,(CURSR)	
	RST	20H	
	DB	7		;OUTHL
	LD	HL,(CURSR)	
	LD	(HL),20H	
	LD	(CURSR),DE	
LRET:	POP	HL	
	POP	DE	
	RET		
;
;************************************
;CURSOR-ADRESSE + 5
;************************************

;
CURIN:	PUSH	HL	
	LD	HL,(CURSR)	
	INC	HL	
	INC	HL	
	INC	HL	
	INC	HL	
	INC	HL	
	LD	(CURSR),HL	
	POP	HL	
	RET		
;
;************************************
;UP	ZUR EINGABE EINES DATENBLOCKS	
; INPUT:HL=AADR.
;OUTPUT:HL=AADR.NAECHSTER BLOCK
;       DE=(DATA)=KOPFADRESSE
;       Z=1 --> BLOCK FEHLERFREI
;************************************

;
BL:	CALL	BITIN	
	CALL	FIFLA	
	LD	C,7	
BLM1:	LD	DE, 0B54h ; 910H		;BLN9...BLN11
	LD	A,8 ; 7	
SW1:	DEC	A	
	JR	NZ, SW1	
	CALL	BITIN	
BLMX:	CALL	BITIN	
	JR	NZ, BL		;VERAENDERUNG ERKANNT?
	DEC	D	
	JR	NZ, BLMX	
	DEC	C	
	JR	Z, BLM4		;SYNC.-FELD ERKANNT?
BLM2:	IN	A, 2	
	XOR	B	
	BIT	6,A	
	JR	NZ, BLM1	;FLANKE ERKANNT?
	DEC	E	
	JR	NZ, BLM2	;WARTESCHLEIFE
	JR	BL		;TIME OUT
;
;7 NULLEN ERKANNT
;
BLM4:	CALL	FIFLA	
	LD	A,55h ; 68	
SW3:	DEC	A	
	JR	NZ, SW3	
	CALL	BITIN	
	JR	NZ, BLM4	;AUF 1 WARTEN
	CALL	FIFLA	
	LD	A,25h ; 30		;BLN4...
SW4:	DEC	A	
	JR	NZ, SW4	
	CALL	WL	
	LD	(DATA),DE	
	PUSH	DE	
	POP	IX		;CS-ANFANGSWERT
	LD	A,20h ; 26		;BLN 10...
	LD	C,16	
SW10:	DEC	A	
	JR	NZ, SW10	
BLM5:	CALL	WL	
	ADD	IX,DE	
	PUSH	BC	
	LD	C,L	
	LD	B,H	
	LD	HL,(ARG2)	;ENDADRESSE
	XOR	A	
	SBC	HL,BC	
	LD	L,C	
	LD	H,B	
	POP	BC	
	JR	C, BLM6	
	LD	(HL),E	
	INC	HL	
	LD	(HL),D	
	JR	BLM7	
BLM6:	LD	A,1		;BLN5...
SW5:	DEC	A	
	JR	NZ, SW5	
	INC	HL	
BLM7:	INC	HL	
	DEC	C	
	JR	Z, BLM8	
	LD	A,16h ; 18		;BLN6...
SW6:	DEC	A	
	JR	NZ, SW6	
	JR	BLM5	
BLM8:	LD	A,16h ; 18		;BLN7
SW7:	DEC	A	
	JR	NZ, SW7	
	CALL	WL		;PRUEFSUMME LESEN
	EX	DE,HL	
	PUSH	IX	
	POP	BC	
	SBC	HL,BC	
	LD	HL,(DATA)	
	EX	DE,HL	
	RET		
;
;************************************
;UP	- EINLESEN EINES WORTES	
;************************************
;
WL:	PUSH	HL	
	LD	L,16	
WLMO:	CALL	BITIN	
	JR	NZ, WLM1	
	XOR	A	
	JR	WLM2	
WLM1:	SCF		
WLM2:	RR	D	
	RR	E	
	CALL	FIFLA	
	DEC	L	
	JR	Z, WLM3	
	LD	A,25h ; 30		;WLN1...
SWLN1:	DEC	A	
	JR	NZ, SWLN1	
	JR	WLMO	
WLM3:	POP	HL	
	RET		
;
;************************************
;UP	- EINGABE EINES BIT	
;************************************
;
BITIN:	IN	A, 2	
	XOR	B	
	BIT	6,A	
	PUSH	AF	
	XOR	B	
	LD	B,A	
	POP	AF	
	RET		
;
;************************************
;UP	- FINDEN EINER FLANKE	
;************************************
;
FIFLA:	IN	A, 2	
	XOR	B	
	BIT	6,A	
	JR	Z, FIFLA	
	RET		
; ;
; ;
; ;***********************************
; ;ZUS		
; ;***********************************
; ; 
; ;	ORG	0E3EEH	
; 	ORG	LORUF + 03EEH	
; ;
; ZMINI:	LD	HL,INITB	;ADR.BELEGUNGSTABELL
; 	LD	DE,MONTB	; ADR. ZUS.-MON-TABELLE --> B0H
; 	LD	BC,6H		; LAENGE TABELLE
; 	LDIR		
; 	RST	38H	
; ;
; INITB:	DB	"L"	
; 	DW	LOAD 	
; 	DB	"S"	
; 	DW	SAVE	
; 	END		
